;/*
gcc -noixemul -W -Wall test_parseix.c -o test_parseix -lauto
quit
*/
/*
 *  by tokai@binaryriot.org
 *  16-Oct-2010
 *
 *  $Id: test_parseix.c,v 1.1 2010/10/16 16:51:55 tokai Exp $
 */

#include <exec/types.h>
#include <libraries/commodities.h>

#include <proto/commodities.h>
#include <proto/dos.h>

struct test_s
{
	STRPTR expression;
	LONG   expected_result;
};

/*  0  == all okay 
 *  -1 == waste characters at end
 *  -2 == description was NULL
 */

static CONST struct test_s testcases[] =
{
	{"control f",        0},
	{"control foobar",  -1},
	{"control f oobar", -1},
	{"foobar",          -1},
	{"f",                0},
	{NULL,              -2},
	{"",                -2},

	/* terminate
	 */
	{NULL, 0xFF},
};

int main(void)
{
	ULONG i;

	for (i=0; testcases[i].expected_result != 0xFF; i++)
	{
		IX tmp;
		LONG rc;

		rc = ParseIX(testcases[i].expression, &tmp);

		Printf("testcase #%lu, expression <%s>, rc %ld vs. %ld\n",
			i, testcases[i].expression, testcases[i].expected_result, rc);

		if (rc != testcases[i].expected_result)
		{
			Printf("\t---> ERROR, rc should be %ld\n", testcases[i].expected_result);
		}
	}

	return 0;
}